/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2004-2013 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: toppers_atk2.c 919 2014-01-09 11:19:14Z fsi-asanoto $
 */

#include "Os.h"
#include "t_syslog.h"
#include "t_stdlib.h"
#include "sysmod/serial.h"
#include "sysmod/syslog.h"
#include "toppers_atk2.h"

#include "sysmod/banner.h"
#include "target_sysmod.h"
#include "target_serial.h"

#include "device.h"

#include "target_hw_counter.h"

/*
 *  ؿץȥ
 */
sint32 main(void);

TASK(main_task);
TASK(hpri_task);
TASK(event_task);
ALARMCALLBACK(func_alarm_callback);


/*
 *  桼ᥤؿ
 *
 *  ץꥱ⡼ɤȽǤȡͥ뵯ư
 */
sint32
main(void){
	/*
	 *  ͥ뵯ư
	 */
	StartOS(AppMode1);

	while(1){
	}
}   /* main */


/*
 *  ȥåץեå롼
 */
#ifdef CFG_USE_STARTUPHOOK
void
StartupHook(void){
	/* ƥǽν */
	syslog_initialize();

	/* Ϥν */
	syslog_msk_log(LOG_UPTO(LOG_INFO));

	/* ꥢIO⥸塼 */
	InitSerial();

	/* ͥ뵯ưåν */
	print_banner();

	/* PSW */
	switch_push_init();

	/* DSW */
	switch_dip_init();
}   /* StartupHook */
#endif /* CFG_USE_STARTUPHOOK */


/*
 * main_task
 */
TASK(main_task){
	uint8 dsw_state;
	uint8 pre_dsw_state = 0;

	syslog(LOG_INFO, "main_task Start!");

	for(;;) {
		/* DSWּ */
		dsw_state = switch_dip_sense();

		/* DSWȽ */
		if(((dsw_state & DSW1) == DSW1) && ((pre_dsw_state & DSW1) != DSW1)){
			syslog(LOG_INFO, "main_task : SetRelAlarm(alarm_callback, TICK_FOR_10MS*100, 0).");
			SetRelAlarm(alarm_callback, TICK_FOR_10MS*100, 0);
		}

		if(((dsw_state & DSW1) != DSW1) && ((pre_dsw_state & DSW1) == DSW1)){
			syslog(LOG_INFO, "main_task : CancelAlarm(alarm_callback).");
			CancelAlarm(alarm_callback);
		}

		if(((dsw_state & DSW2) == DSW2) && ((pre_dsw_state & DSW2) != DSW2)){
			syslog(LOG_INFO, "main_task : SetRelAlarm(alarm_callback, TICK_FOR_10MS*100, TICK_FOR_10MS*100).");
			SetRelAlarm(alarm_callback, TICK_FOR_10MS*100, TICK_FOR_10MS*100);
		}

		if(((dsw_state & DSW2) != DSW2) && ((pre_dsw_state & DSW2) == DSW2)){
			syslog(LOG_INFO, "main_task : CancelAlarm().");
			CancelAlarm(alarm_callback);
		}

		if(((dsw_state & DSW3) == DSW3) && ((pre_dsw_state & DSW3) != DSW3)){
			syslog(LOG_INFO, "main_task : SetRelAlarm(alarm_event, TICK_FOR_10MS*50, TICK_FOR_10MS*50).");
			SetRelAlarm(alarm_event, TICK_FOR_10MS*50, TICK_FOR_10MS*50);
		}

		if(((dsw_state & DSW3) != DSW3) && ((pre_dsw_state & DSW3) == DSW3)){
			syslog(LOG_INFO, "main_task : CancelAlarm(alarm_event).");
			CancelAlarm(alarm_event);
		}

		if(((dsw_state & DSW4) == DSW4) && ((pre_dsw_state & DSW4) != DSW4)){
			syslog(LOG_INFO, "main_task : SetRelAlarm(alarm_act_task, TICK_FOR_10MS*20, TICK_FOR_10MS*20).");
			SetRelAlarm(alarm_act_task, TICK_FOR_10MS*20, TICK_FOR_10MS*20);
		}

		if(((dsw_state & DSW4) != DSW4) && ((pre_dsw_state & DSW4) == DSW4)){
			syslog(LOG_INFO, "main_task : CancelAlarm(alarm_act_task).");
			CancelAlarm(alarm_act_task);
		}

		pre_dsw_state = dsw_state;
	}
}	/* TASK( main_task ) */


/*
 * hpri_task(ͥ٥)
 */
TASK(hpri_task){
	syslog(LOG_INFO, "hpri_task Start!");
	syslog(LOG_INFO, "hpri_task End!");

	TerminateTask();
}	/* TASK( hpri_task ) */


/*
 * event_task(٥Ԥ)
 */
TASK(event_task){
	syslog(LOG_INFO, "event_task Start!");

	for(;;){
		WaitEvent(EVENT_WUP);
		syslog(LOG_INFO, "event_task : Wake Up!!");
		ClearEvent(EVENT_WUP);
	}

	TerminateTask();
}	/* TASK( event_task ) */


/*
 * 顼ॳХåؿ
 */
ALARMCALLBACK(func_alarm_callback){
	syslog(LOG_INFO, "func_alarm_callback() : called!");
}
